From 59fd6c81cc3f97c2ca48bddffd346f77b7a9d58b Mon Sep 17 00:00:00 2001
From: Jaesup Kwak <veshboo@gmail.com>
Date: Sat, 16 Dec 2017 00:50:47 +0900
Subject: [PATCH] Page up/down by emacs window height (Bug#29565)

'xwidget-window-inside-pixel-height' is more reliable than javascript
'window.document.body.clientHeight' for scroll up/down by page.

* lisp/xwidget.el (xwidget-webkit-scroll-up)
(xwidget-webkit-scroll-down)
---
 lisp/xwidget.el | 8 ++++++--
 1 file changed, 6 insertions(+), 2 deletions(-)

diff --git a/lisp/xwidget.el b/lisp/xwidget.el
index acd3ea2a5b..a218868965 100644
--- a/lisp/xwidget.el
+++ b/lisp/xwidget.el
@@ -181,7 +181,9 @@ xwidget-webkit-scroll-up
   (interactive "P")
   (xwidget-webkit-execute-script
    (xwidget-webkit-current-session)
-   (cond ((null n) "window.scrollBy(0, window.document.body.clientHeight);")
+   (cond ((null n)
+          (format "window.scrollBy(0, %d);"
+                  (xwidget-window-inside-pixel-height (selected-window))))
          (t (format "window.scrollBy(0, %d);" n)))))
 
 (defun xwidget-webkit-scroll-down (&optional n)
@@ -191,7 +193,9 @@ xwidget-webkit-scroll-down
   (interactive "P")
   (xwidget-webkit-execute-script
    (xwidget-webkit-current-session)
-   (cond ((null n) "window.scrollBy(0, -window.document.body.clientHeight);")
+   (cond ((null n)
+          (format "window.scrollBy(0, %d);"
+                  (- (xwidget-window-inside-pixel-height (selected-window)))))
          (t (format "window.scrollBy(0, %d);" (- n))))))
 
 (defvar xwidget-webkit-scroll-line-height 50
-- 
2.15.0

